﻿//編集中のテキスト内文字数をカウントするサンプルです

//.NETライブラリのインポート
import System;

//エディタから全文取得
//文字列を扱う際はStringBuilderを使うと高速なんだそうです
var s = new System.Text.StringBuilder(Document.Text);

//変数を宣言し初期値ゼロにセット
var mSbSpace = 0;
var mDbSpace = 0;
var mTab = 0;
var mCR = 0;
var mLF = 0;
var mCRLF =0;
var mOther = 0;

//CRLFを検出した場合のフラグ
var Skip = false;

//一文字ずつチェックし、該当する変数を増やす
for (var i=0; i<s.Length; i++)
{
	if (Skip)
	{
		Skip = false;
	}
	else
	{
		switch (s[i])
		{
			case 0x20:
				mSbSpace++;
				break;
			case 0x3000:
				mDbSpace++;
				break;
			case 9:
				mTab++;
				break;
			case 0xD:
				if (i<s.Length-1)
				{
					if (s[i+1]==10)
					{
						mCRLF++;
						Skip = true;
					}
					else mCR++;
				}
				else mCR++;
				break;
			case 0xA:
				mLF++;
				break;
			default:
				mOther++;
		}
	}
}

//結果をダイアログボックスで表示するため文字列として並べる
var m = "半角スペース  :  " + mSbSpace + "\r\n" +
		"全角スペース  :  " + mDbSpace + "\r\n" +
		"タブ文字(\\t)  :  " + mTab + "\r\n" +
		"改行(\\r)  :  " + mCR + "\r\n" +
		"改行(\\n)  :  " + mLF + "\r\n" +
		"改行(\\r\\n)  :  " + mCRLF + "\r\n" +
		"その他の文字  :  " + mOther + "\r\n";

//タイトルバーが「ぎょえ」のダイアログボックス表示
Dialog.Alert(m);

//プログラム/アセンブリ情報
//この部分はなくても動作します
[assembly: System.Reflection.AssemblyVersion('1.0.*')]
[assembly: System.Reflection.AssemblyTitle('文字数カウントプラグイン')]
[assembly: System.Reflection.AssemblyCopyright('http://www5.plala.or.jp/wantech/')]
